%define have_llvm 0

Name:           FreeMat
Version:        4.2
Release:        %mkrel 2
Summary:        An interpreted, matrix-oriented development environment
License:        GPL-2.0+
Group:          Sciences/Engineering
Url:            http://freemat.sourceforge.net
Source0:        %{name}-%{version}beta-Source.tar.xz
Source1:	freemat.xpm
Source2:	%{name}_modules.txt
Patch1:         FreeMat-4.1_fixes.patch
Patch2:         FreeMat-4.1_portaudio.patch
Patch3:         FreeMat-4.1_use_llvm.patch
Patch4:         FreeMat-4.1_local_libffi.patch
Patch5:         FreeMat-4.1_have_fftw.patch

BuildRequires:	%{_lib}amd-devel %{_lib}fftw-devel %{_lib}ffi5-devel %{_lib}boost-devel
BuildRequires:	cmake f2c gcc-gfortran ffcall-devel libatlas-devel
BuildRequires:	ncurses-devel
BuildRequires:	pcre-devel
BuildRequires:	%{_lib}portaudio2-devel
BuildRequires:	qt4-devel
BuildRequires:	%{_lib}umfpack-devel
BuildRequires:	zlib-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Freemat is an intepreted, matrix-oriented development environment for
engineering and scientific applications, similar to the commercial package
MATLAB. Freemat provides visualization, image manipulation, and plotting as
well as parallel programming.

%prep
%setup -q -n %{name}-%{version}beta-Source
rm -f CMakeCache.txt
rm -f `find -name "*.moc.cpp"`
%patch1
%patch2
%patch3
#%%patch4
#%%patch5
# they've hardcoded libffi include path for Fedora, I can do this too ...
libffi_path="$(find  /usr/lib*/ -maxdepth 1 -type d -name "libffi*" \
        |sort  |tail -n 1)"
if test -n "$libffi_path" ;then
        sed -i "s,/usr/lib64/libffi-[0-9\.]*,${libffi_path}," CMakeLists.txt
fi


%build
mkdir -p dependencies/libffi/build
pushd dependencies/libffi/build
sh ../configure --disable-shared
make
popd

mkdir build
cd build
cmake \
        -DCMAKE_INSTALL_PREFIX=%{_prefix} \
        -DCMAKE_CXX_FLAGS=%{optflags} \
        -DCMAKE_C_FLAGS=%{optflags} \
        -DCMAKE_SKIP_RPATH="YES" \
        -DPCRE_SUPPORT_UTF8="ON" \
%if %{have_llvm}
        -DUSE_LLVM="ON" \
        -DLLVM_INCLUDE_DIR=%{_includedir}/llvm/ \
%else
        -DUSE_LLVM="OFF" \
%endif
        -DAMD_SYS_INCLUDE_DIR=%{_includedir} \
        -DRESOURCEDIR=%{_datadir}/%{name} \
        -DFORCE_BUNDLED_AMD=ON \
        -DFORCE_BUNDLED_PCRE=OFF \
        -DFORCE_BUNDLED_PORTAUDIO=OFF \
        -DFORCE_BUNDLED_UMFPACK=ON \
        -DFORCE_BUNDLED_ZLIB=OFF \
        ..
%make



%install
cd build
%makeinstall_std DESTDIR=%{buildroot}
ln -sf FreeMat %{buildroot}%{_bindir}/freemat

# icon
mkdir -p $RPM_BUILD_ROOT/%_datadir/pixmaps/freemat/
install -m 0644 %{SOURCE1} $RPM_BUILD_ROOT/%_datadir/pixmaps/freemat/freemat.xpm

# make launcher
mkdir -p $RPM_BUILD_ROOT/%_datadir/applications
cat > $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Version=1.0
Comment=a free environment for rapid engineering and scientific prototyping and data processing.
Exec=freemat
GenericName=Scientific Software Package
Icon=/usr/share/pixmaps/freemat/freemat.xpm
Name=FreeMat
StartupNotify=false
Terminal=false
Type=Application
Categories=Development;Science;Math;Engineering;
StartupNotify=true
EOF

# fix Help documentation
mkdir -p $RPM_BUILD_ROOT/%_datadir/%{name}-%{version}/help/html/
install -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/%_datadir/%{name}-%{version}/help/html/modules.txt

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc COPYING ChangeLog
%{_bindir}/freemat
%{_bindir}/FreeMat
%{_bindir}/blas.ini
%{_datadir}/%{name}-%{version}
%{_datadir}/applications/%{name}.desktop
%{_datadir}/pixmaps/freemat/freemat.xpm

%changelog
* Wed Nov 06 2013 billybot <billybot> 4.2-2pclos2013
- rebuld for new pcre
- fix rpmgroup

* Mon Oct 07 2013 pinoc <vogtpet at gmail.com> 4.2-1pclos2013
- imported package
- added menu launcher
- fixed Help menu (Source2)

